import {
  Controller,
  Post,
  Delete,
  Route,
  Security,
  Tags,
  Body,
  Path,
  Request,
  Get,
  Patch,
} from "tsoa";
import HttpSuccess from "../interfaces/http-success";
import HttpError from "../interfaces/http-error";
import HttpStatus from "../interfaces/http-status";
import {
  ProfileEducation,
  UpdateProfileEducation,
  CreateProfileEducationEmployee,
} from "../entities/ProfileEducation";
import { RequestWithUser } from "../middlewares/user";
import { ProfileEducationHistory } from "../entities/ProfileEducationHistory";
import { AppDataSource } from "../database/data-source";
import { ProfileEmployee } from "../entities/ProfileEmployee";
import permission from "../interfaces/permission";
import { setLogDataDiff } from "../interfaces/utils";
@Route("api/v1/org/profile-employee/educations")
@Tags("ProfileEducationsEmployee")
@Security("bearerAuth")
export class ProfileEducationsEmployeeController extends Controller {
  private profileEmployeeRepo = AppDataSource.getRepository(ProfileEmployee);
  private profileEducationRepo = AppDataSource.getRepository(ProfileEducation);
  private profileEducationHistoryRepo = AppDataSource.getRepository(ProfileEducationHistory);

  @Get("user")
  public async detailProfileEducationUser(@Request() request: { user: Record<string, any> }) {
    const profile = await this.profileEmployeeRepo.findOneBy({ keycloak: request.user.sub });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    const getProfileEducation = await this.profileEducationRepo.find({
      where: { profileEmployeeId: profile.id },
      order: { createdAt: "ASC" },
    });
    if (!getProfileEducation) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }
    return new HttpSuccess(getProfileEducation);
  }

  @Get("{profileEmployeeId}")
  public async detailProfileEducation(
    @Path() profileEmployeeId: string,
    @Request() req: RequestWithUser,
  ) {
    let _workflow = await new permission().Workflow(req, profileEmployeeId, "SYS_REGISTRY_EMP");
    if (_workflow == false)
      await new permission().PermissionOrgUserGet(req, "SYS_REGISTRY_EMP", profileEmployeeId);
    const getProfileEducation = await this.profileEducationRepo.find({
      where: { profileEmployeeId: profileEmployeeId },
      order: { createdAt: "ASC" },
    });
    if (!getProfileEducation) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }
    return new HttpSuccess(getProfileEducation);
  }

  @Get("admin/history/{educationId}")
  public async getProfileAdminEducationHistory(
    @Path() educationId: string,
    @Request() req: RequestWithUser,
  ) {
    const _record = await this.profileEducationRepo.findOneBy({ id: educationId });
    if (_record) {
      let _workflow = await new permission().Workflow(req, educationId, "SYS_REGISTRY_EMP");
      if (_workflow == false)
        await new permission().PermissionOrgUserGet(
          req,
          "SYS_REGISTRY_EMP",
          _record.profileEmployeeId,
        );
    }

    const record = await this.profileEducationHistoryRepo.find({
      where: {
        profileEducationId: educationId,
      },
      order: { createdAt: "DESC" },
    });
    if (!record) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }
    return new HttpSuccess(record);
  }

  @Get("history/{educationId}")
  public async getProfileEducationHistory(@Path() educationId: string) {
    const record = await this.profileEducationHistoryRepo.find({
      where: {
        profileEducationId: educationId,
      },
      order: { createdAt: "DESC" },
    });
    if (!record) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }
    return new HttpSuccess(record);
  }

  @Post()
  public async newProfileEducation(
    @Request() req: RequestWithUser,
    @Body() body: CreateProfileEducationEmployee,
  ) {
    if (!body.profileEmployeeId) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "กรุณากรอก profileEmployeeId");
    }

    const profile = await this.profileEmployeeRepo.findOneBy({ id: body.profileEmployeeId });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    await new permission().PermissionOrgUserUpdate(req, "SYS_REGISTRY_EMP", profile.id);
    const before = null;
    const data = new ProfileEducation();
    const meta = {
      createdUserId: req.user.sub,
      createdFullName: req.user.name,
      lastUpdateUserId: req.user.sub,
      lastUpdateFullName: req.user.name,
      createdAt: new Date(),
      lastUpdatedAt: new Date(),
    };

    Object.assign(data, { ...body, ...meta });
    const history = new ProfileEducationHistory();
    Object.assign(history, { ...data, id: undefined });

    await this.profileEducationRepo.save(data, { data: req });
    setLogDataDiff(req, { before, after: data });
    history.profileEducationId = data.id;
    await this.profileEducationHistoryRepo.save(history, { data: req });
    //setLogDataDiff(req, { before, after: history });

    return new HttpSuccess();
  }

  @Patch("{educationId}")
  public async editProfileEducation(
    @Body() body: UpdateProfileEducation,
    @Request() req: RequestWithUser,
    @Path() educationId: string,
  ) {
    const record = await this.profileEducationRepo.findOneBy({ id: educationId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    await new permission().PermissionOrgUserUpdate(
      req,
      "SYS_REGISTRY_EMP",
      record.profileEmployeeId,
    );
    const before = structuredClone(record);
    const before_null = null;
    const history = new ProfileEducationHistory();

    Object.assign(record, body);
    Object.assign(history, { ...record, id: undefined });

    history.profileEducationId = educationId;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = new Date();
    history.lastUpdateUserId = req.user.sub;
    history.lastUpdateFullName = req.user.name;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = new Date();
    history.lastUpdatedAt = new Date();

    await Promise.all([
      this.profileEducationRepo.save(record, { data: req }),
      setLogDataDiff(req, { before, after: record }),
      this.profileEducationHistoryRepo.save(history, { data: req }),
      setLogDataDiff(req, { before, after: history }),
    ]);

    return new HttpSuccess();
  }

  @Delete("{educationId}")
  public async deleteProfileEducation(
    @Path() educationId: string,
    @Request() req: RequestWithUser,
  ) {
    const _record = await this.profileEducationRepo.findOneBy({ id: educationId });
    if (_record) {
      await new permission().PermissionOrgUserDelete(
        req,
        "SYS_REGISTRY_EMP",
        _record.profileEmployeeId,
      );
    }

    await this.profileEducationHistoryRepo.delete({
      profileEducationId: educationId,
    });

    const result = await this.profileEducationRepo.delete({ id: educationId });

    if (result.affected == undefined || result.affected <= 0) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }

    return new HttpSuccess();
  }
}
